from doubletalk.bookset import BookSet
from doubletalk.transac import Transaction, tranFromString, tranFromTuple



#from AccessControl import ClassSecurityInfo, getSecurityManager
from Globals import InitializeClass, DTMLFile
from Acquisition import Implicit
from Globals import Persistent, PersistentMapping
from AccessControl.Role import RoleManager
from OFS.SimpleItem import Item, SimpleItem
#from OFS.Folder import Folder
from OFS.PropertyManager import PropertyManager
#from Acquisition import aq_base, aq_parent, aq_inner, aq_acquire

from DateTime import DateTime
#from Products.ZCatalog.CatalogPathAwareness import CatalogAware



addLedgerForm = DTMLFile('www/newLedger', globals() )
def addLedger(self, id, title, REQUEST=None ):
    "add new Ledger Product"
    new = Ledger(id, title )
    self._setObject(id, new )
    return self.manage_main(self, REQUEST)

class Ledger(Persistent,SimpleItem):
    "Doubletalk Bookset Product"
    meta_type='Ledger'

    manage_options=(
        {'label':'Journal', 'action':'showJournal'},
        {'label':'Balances', 'action': 'showBalances'},
        {'label':'Account', 'action': 'showAccount'},
        {'label' : 'addTr','action' : 'addTrForm', },
        ) + SimpleItem.manage_options
    
    
    def __init__(self, id, title ):
        self.id = id
        self.title = title
        self.bs = BookSet()
        
    addTrForm=DTMLFile('www/addTr', globals() )
    def addTr(self, chunk , REQUEST=None ):
        "build and add Transaction"
        tr = tranFromString( chunk)
        #tr.date = DateTime()
        
        #tr.validate(autocorrect=1)
        self.bs.add(tr)
        self.__changed__(1)
        if REQUEST is not None:
            return self.showJournal(manage_tabs_message='Trans added' )
        
    def addTrFromTuple(self, *args ):
        "build and add Transaction"
        tr = tranFromTuple(args)
        self.bs.add(tr)
        self.__changed__(1)
        
    #editTrForm=DTMLFile('www/editTr', globals() )
    
    def getJournal(self ):
        "access to ledger journal"
        return self.bs #._BookSet__journal
    #def __getitem__(self, idx ):
    #    "forwarder"
    #    return self.bs[idx]

    def getAccountDetails(self, acc ):
        "get Account Details"
        return self.bs.getAccountDetails(acc)
        #(tranNo, dateStr, comment, delta, runtot)
    
    def getAccountList(self):
        "get Accounts "
        return self.bs.getAccountList()
    

    showJournal=DTMLFile('www/journal', globals() )
    showAccount=DTMLFile('www/showAcc', globals() )
    showBalances=DTMLFile('www/showBalances', globals() )
    def getAllBalancesOn(self, date=None ):
        "get current account balances "
        return self.bs.getAllBalancesOn( )
    
    def getAccountBalance(self, acc, date=None ):
        "get account balacne"
        return self.bs.getAccountBalance( acc )
    
    

InitializeClass(Ledger)
